## ceph 15.1.0

=== debian/changelog ===
ceph (15.1.0-0ubuntu3) focal; urgency=medium

  * d/*.symbols: Update symbols files for new release.

 -- James Page <james.page@ubuntu.com>  Fri, 21 Feb 2020 08:51:34 +0000

ceph (15.1.0-0ubuntu2) focal; urgency=medium

  * d/rules,control: Disable Kafka endpoint support for RGW.

 -- James Page <james.page@ubuntu.com>  Mon, 10 Feb 2020 11:53:47 +0000

ceph (15.1.0-0ubuntu1) focal; urgency=medium

  * SECURITY UPDATE: New upstream release (LP: #1861789) including
    fixes for:
    - CVE-2020-1699
    - CVE-2020-1700
  * d/p/32466.patch-*: Drop, included in release.
  * New upstream release candidate for Octopus.
  * d/p/32bit-avoid-overloading.patch,32bit-avoid-size_t.patch,bluefs-
    use-uint64_t-for-len.patch,fix-clang-build.patch: Drop, no longer
    needed.
  * Sync packaging changes with upstream:
    - d/control,rules,ceph-mgr-ssh.*: Drop ceph-mgr-ssh package.
    - d/control,rules,{ceph-mgr-}cephadm.*: Add new ceph-mgr-cephadm
      and cephadm packages, install sudoers file.
    - d/control,ceph-immutable-object-cache.*: Add new
      ceph-immutable-object-cache package.
    - d/control,python3-ceph-common.install: Add new python3-ceph-common
      package.
  * d/*: wrap-and-sort -bast.
  * d/control: Add librdkafka-dev to BD's.
  * d/p/32bit-fixes.patch: Misc fixes for compilation failures on 32 bit
    architectures.

 -- James Page <james.page@ubuntu.com>  Fri, 07 Feb 2020 11:24:29 +0000

ceph (14.2.5-3ubuntu5) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:03:18 +0000

ceph (14.2.5-3ubuntu4) focal; urgency=medium

  * d/rules: Don't switch to using clang for armhf on Ubuntu as g++
    is just fine and does not produce an over linked set of binaries.

 -- James Page <james.page@ubuntu.com>  Mon, 27 Jan 2020 09:20:28 +0000

ceph (14.2.5-3ubuntu3) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 05:46:31 +0000

ceph (14.2.5-3ubuntu2) focal; urgency=medium

  * d/control: Recommends->Suggests on ceph-fuse for ceph-mds
    package to avoid main inclusion.
  * d/rules: Skip radosgw, ceph-common and rbd-mirror packages on i386.

 -- James Page <james.page@ubuntu.com>  Tue, 14 Jan 2020 09:27:03 +0000

ceph (14.2.5-3ubuntu1) focal; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - d/control: Add missing Depends on python3-{distutils,routes} to
      ceph-mgr-dashboard package (LP: #1858304).
  * All other changes merged into Debian packaging (Thanks Bernd).
  * d/control: Fix misnamed package Recommends brbd1 -> librbd1.
  * d/control: Add missing debhelper misc:Depends for python3-ceph.

 -- James Page <james.page@ubuntu.com>  Fri, 10 Jan 2020 09:22:49 +0000

ceph (14.2.4-0ubuntu3) focal; urgency=medium

  * Drop uninstallable and unneeded server binaries on i386.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 21 Dec 2019 17:05:10 -0600

ceph (14.2.4-0ubuntu2) focal; urgency=medium

  [ Dariusz Gadomski ]
  * d/p/issue37490.patch: Cherry pick fix to optimize LVM queries in
    ceph-volume, resolving performance issues in systems under heavy load
    or with large numbers of disks (LP: #1850754).

  [ James Page ]
  * d/p/issue40114.patch: Cherry pick endian fixes to resolve issues
    using Ceph on big-endian architectures such as s390x (LP: #1851290).

 -- Dariusz Gadomski <dariusz.gadomski@canonical.com>  Wed, 06 Nov 2019 11:08:53 +0100

ceph (14.2.4-0ubuntu1) focal; urgency=medium

  * New upstream release (LP: #1850901):
    - d/p/more-py3-compat.patch,ceph-volume-wait-for-lvs.patch,
      ceph-volume-wait-for-lvs.patch: Drop, included upstream.
    - d/p/bluefs-use-uint64_t-for-len.patch: Cherry pick fix to resolve
      FTBFS on 32 bit architectures.

 -- James Page <james.page@ubuntu.com>  Mon, 04 Nov 2019 14:10:20 +0000

ceph (14.2.2-0ubuntu4) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:38:16 +0000

=== debian/control ===
Source: ceph
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Ceph Packaging Team <team+ceph@tracker.debian.org>
Uploaders:
 James Page <jamespage@debian.org>,
 Gaudenz Steinlin <gaudenz@debian.org>,
 Bernd Zeimetz <bzed@debian.org>,
Homepage: http://ceph.com/
Vcs-Git: https://salsa.debian.org/ceph-team/ceph.git
Vcs-Browser: https://salsa.debian.org/ceph-team/ceph
Build-Depends:
 clang [armhf mipsel armel m68k sh4],
 cmake,
 cython,
 cython3,
 debhelper (>= 10~),
 default-jdk,
 dh-exec,
 dh-python,
 dpkg-dev (>= 1.16.1~),
 gperf,
 javahelper,
 junit4,
 libaio-dev,
 libbabeltrace-ctf-dev,
 libbabeltrace-dev,
 libblkid-dev (>= 2.17),
 libboost-atomic-dev (>= 1.71.0),
 libboost-chrono-dev (>= 1.71.0),
 libboost-context-dev (>= 1.71.0) [!s390x !mips64el !ia64 !m68k !ppc64 !riscv64 !sh4 !sparc64 !x32],
 libboost-coroutine-dev (>= 1.71.0) [!s390x !mips64el !ia64 !m68k !ppc64 !riscv64 !sh4 !sparc64 !x32],
 libboost-date-time-dev (>= 1.71.0),
 libboost-iostreams-dev (>= 1.71.0),
 libboost-program-options-dev (>= 1.71.0),
 libboost-python-dev (>= 1.71.0),
 libboost-random-dev (>= 1.71.0),
 libboost-regex-dev (>= 1.71.0),
 libboost-system-dev (>= 1.71.0),
 libboost-thread-dev (>= 1.71.0),
 libbz2-dev,
 libcap-ng-dev,
 libcunit1-dev,
 libcurl4-gnutls-dev,
 libedit-dev,
 libexpat1-dev,
 libfuse-dev,
 libgoogle-perftools-dev [i386 amd64 powerpc armhf arm64 ppc64el],
 libibverbs-dev,
 libkeyutils-dev,
 libldap2-dev,
 libleveldb-dev,
 liblz4-dev (>= 0.0~r131),
 libncurses-dev,
 libnl-3-dev,
 libnl-genl-3-dev,
 libnss3-dev,
 liboath-dev,
 librabbitmq-dev,
 librdmacm-dev,
 libsnappy-dev,
 libssl-dev,
 libtool,
 libudev-dev,
 libxml2-dev,
 lsb-release,
 pkg-config,
 python3-cherrypy3,
 python3-dev,
 python3-pecan,
 python3-setuptools,
 python3-sphinx,
 tox,
 uuid-runtime,
 valgrind [amd64 armhf i386 powerpc],
 virtualenv,
 xfslibs-dev,
 yasm [amd64],
 zlib1g-dev,
Build-Conflicts:
 libcrypto++-dev,
Standards-Version: 4.2.1

Package: ceph
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-mgr (= ${binary:Version}),
 ceph-mon (= ${binary:Version}),
 ceph-osd (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 ceph-mds (= ${binary:Version}),
Description: distributed storage and file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.

Package: ceph-base
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 binutils,
 ceph-common (= ${binary:Version}),
 cryptsetup-bin | cryptsetup,
 gdisk,
 hdparm | sdparm,
 parted,
 uuid-runtime,
 xfsprogs,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
 ceph-common (<< 9.2.0-0~),
 ceph-test (<< 12.2.8+dfsg1-1~),
 python-ceph (<< 0.94.1-1~),
Replaces:
 ceph (<< 12.2.8+dfsg1-1~),
 ceph-common (<< 9.2.0-0~),
 ceph-test (<< 12.2.8+dfsg1-1~),
 python-ceph (<< 0.94.1-1~),
Recommends:
 ceph-mds (= ${binary:Version}),
 chrony | time-daemon | ntp,
 librados2 (= ${binary:Version}),
 librbd1 (= ${binary:Version}),
Suggests:
 btrfs-tools,
 logrotate,
Description: common ceph daemon libraries and management tools
 Ceph is a distributed storage system designed to provide excellent
 performance, reliability, and scalability.
 .
 This package contains the libraries and management tools that are common among
 the Ceph server daemons (ceph-mon, ceph-mgr, ceph-osd, ceph-mds). These tools
 are necessary for creating, running, and administering a Ceph storage cluster.

Package: ceph-common
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 librbd1 (= ${binary:Version}),
 python3-ceph-argparse (= ${binary:Version}),
 python3-ceph-common (= ${binary:Version}),
 python3-cephfs (= ${binary:Version}),
 python3-prettytable,
 python3-rados (= ${binary:Version}),
 python3-rbd (= ${binary:Version}),
 python3-requests,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Conflicts:
 ceph-client-tools,
Breaks:
 ceph (<< 9.2.0-0~),
 ceph-base (<< 12.2.10+dfsg1-1~),
 ceph-fs-common (<< 12.2.10+dfsg1-1~),
 ceph-mds (<< 14.2.5-3~),
 ceph-test (<< 9.2.0-0~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0~),
Replaces:
 ceph (<< 9.2.0-0~),
 ceph-client-tools,
 ceph-fs-common (<< 12.2.8+dfsg1-1~),
 ceph-mds (<< 14.2.5-3~),
 ceph-test (<< 9.2.0-1~),
 librbd1 (<< 0.94.1-1~),
 python-ceph (<< 0.94.1-1~),
 radosgw (<< 12.0.3-0~),
Suggests:
 ceph,
 ceph-mds,
Description: common utilities to mount and interact with a ceph storage cluster
 Ceph is a distributed storage and file system designed to provide
 excellent performance, reliability, and scalability.  This is a collection
 of common tools that allow one to interact with and administer a Ceph cluster.

Package: ceph-fuse
Architecture: amd64
Depends:
 python3,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends:
 fuse,
Description: FUSE-based client for the Ceph distributed file system
 Ceph is a distributed network file system designed to provide
 excellent performance, reliability, and scalability.  This is a
 FUSE-based client that allows one to mount a Ceph file system without
 root privileges.
 .
 Because the FUSE-based client has certain inherent performance
 limitations, it is recommended that the native Linux kernel client
 be used if possible.  If it is not practical to load a kernel module
 (insufficient privileges, older kernel, etc.), then the FUSE client will
 do.

Package: ceph-immutable-object-cache
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 librados2 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Ceph daemon for immutable object cache
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.  This is a daemon for immutable
 object cache.

Package: ceph-mds
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ceph-common,
 libcephfs2,
Suggests:
 ceph-fuse,
Breaks:
 ceph (<< 0.67.3-1),
Replaces:
 ceph (<< 0.67.3-1),
Description: metadata server for the ceph distributed file system
 Ceph is a distributed storage and network file system designed to
 provide excellent performance, reliability, and scalability.
 .
 This package contains the metadata server daemon, which is used to
 create a distributed file system on top of the ceph storage cluster.

Package: ceph-mgr
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-jwt,
 python3-openssl,
 python3-pecan,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 0.93-417),
Breaks:
 ceph (<< 0.93-417),
Suggests:
 ceph-mgr-cephadm,
 ceph-mgr-dashboard,
 ceph-mgr-diskprediction-cloud,
 ceph-mgr-diskprediction-local,
 ceph-mgr-k8sevents,
 ceph-mgr-rook,
Description: manager for the ceph distributed file system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the manager daemon, which is used to expose high
 level management and monitoring functionality.

Package: ceph-mgr-cephadm
Architecture: all
Depends:
 ceph-mgr (= ${binary:Version}),
 cephadm,
 openssh-client,
 python3-six,
 ${misc:Depends},
 ${python:Depends},
Description: cephadm orchestrator plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the CEPHADM plugin for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to perform orchestration functions
 over a standard SSH connection.

Package: ceph-mgr-dashboard
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-bcrypt,
 python3-cherrypy3,
 python3-distutils,
 python3-jwt,
 python3-openssl,
 python3-routes,
 python3-werkzeug,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: dashboard plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package provides a ceph-mgr plugin, providing a web-based
 application to monitor and manage many aspects of a Ceph cluster and
 related components.
 .
 See the Dashboard documentation at http://docs.ceph.com/ for details
 and a detailed feature overview.

Package: ceph-mgr-diskprediction-cloud
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: diskprediction-cloud plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_cloud plugin for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-diskprediction-local
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-numpy,
 python3-scipy,
 python3-sklearn,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: diskprediction-local plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the diskprediction_local plugin for the ceph-mgr
 daemon, which helps predict disk failures.

Package: ceph-mgr-k8sevents
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-kubernetes,
 ${misc:Depends},
 ${python:Depends},
Description: kubernetes events plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the k8sevents plugin, to allow ceph-mgr to send
 ceph related events to the kubernetes events API, and track all events
 that occur within the rook-ceph namespace.

Package: ceph-mgr-rook
Architecture: all
Depends:
 ceph-mgr (>= ${binary:Version}),
 python3-six,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: rook plugin for ceph-mgr
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the rook plugin for ceph-mgr's orchestration
 functionality, to allow ceph-mgr to install and configure ceph using
 Rook.

Package: ceph-mon
Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 m68k mips64el powerpc ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Depends:
 ceph-base (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Replaces:
 ceph (<< 10.2.2-0ubuntu2~),
Breaks:
 ceph (<< 10.2.2-0ubuntu2~),
Description: monitor server for the ceph storage system
 Ceph is a massively scalable, open-source, distributed
 storage system that runs on commodity hardware and delivers object,
 block and file system storage.
 .
 This package contains the cluster monitor daemon for the Ceph storage
 system. One or more instances of ceph-mon form a Paxos part-time parliament
 cluster that provides extremely reliable and durable storage of cluster

## ceph 15.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
# remove cmake/modules/FindPython* once 3.12 is required

project(ceph
  VERSION 15.1.0
  LANGUAGES CXX C ASM)

foreach(policy
    CMP0028
    CMP0046
    CMP0048
    CMP0051
    CMP0054
    CMP0056
    CMP0065
    CMP0075)
  if(POLICY ${policy})
    cmake_policy(SET ${policy} NEW)
  endif()
endforeach()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
  set(LINUX ON)
  FIND_PACKAGE(Threads)
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
  set(FREEBSD ON)
  FIND_PACKAGE(Threads)
endif(CMAKE_SYSTEM_NAME MATCHES "Linux")

if(WIN32)
  # The Windows headers (e.g. coming from mingw or the Windows SDK) check
  # the targeted Windows version. The availability of certain functions and
  # structures will depend on it.
  set(WIN32_WINNT "0x0A00" CACHE STRING "Targeted Windows version.")
  add_definitions(-D_WIN32_WINNT=${WIN32_WINNT})
endif()

if(MINGW)
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-allow-multiple-definition")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-allow-multiple-definition")
endif()

option(WITH_CCACHE "Build with ccache.")
if(WITH_CCACHE)
  find_program(CCACHE_FOUND ccache)
  if(NOT CCACHE_FOUND)
    message(FATAL_ERROR "Can't find ccache. Is it installed?")
  endif()
  message(STATUS "Building with ccache: ${CCACHE_FOUND}, CCACHE_DIR=$ENV{CCACHE_DIR}")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  # ccache does not accelerate link (ld), but let it handle it. by passing it
  # along with cc to python's distutils, we are able to workaround
  # https://bugs.python.org/issue8027.
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(WITH_CCACHE)

option(WITH_MANPAGE "Build man pages." ON)
if(WITH_MANPAGE)
  find_program(SPHINX_BUILD
    NAMES sphinx-build sphinx-build-3)
  if(NOT SPHINX_BUILD)
    message(FATAL_ERROR "Can't find sphinx-build.")
  endif(NOT SPHINX_BUILD)
endif(WITH_MANPAGE)

include_directories(
  ${PROJECT_BINARY_DIR}/src/include
  ${PROJECT_SOURCE_DIR}/src)

if(OFED_PREFIX)
  include_directories(SYSTEM ${OFED_PREFIX}/include)
  link_directories(${OFED_PREFIX}/lib)
endif()

if(FREEBSD)
  include_directories(SYSTEM /usr/local/include)
  link_directories(/usr/local/lib)
  list(APPEND CMAKE_REQUIRED_INCLUDES /usr/local/include)
endif(FREEBSD)


#put all the libs and binaries in one place
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

include(CephChecks)

set(CEPH_MAN_DIR "share/man" CACHE STRING "Install location for man pages (relative to prefix).")

option(ENABLE_SHARED "build shared libraries" ON)
if(ENABLE_SHARED)
  set(CEPH_SHARED SHARED)
else(ENABLE_SHARED)
  set(CEPH_SHARED STATIC)
endif(ENABLE_SHARED)
set(CMAKE_POSITION_INDEPENDENT_CODE ${ENABLE_SHARED})

option(WITH_STATIC_LIBSTDCXX "Link against libstdc++ statically" OFF)
if(WITH_STATIC_LIBSTDCXX)
  if(NOT CMAKE_COMPILER_IS_GNUCXX)
    message(FATAL_ERROR "Please use GCC to enable WITH_STATIC_LIBSTDCXX")
  endif()
  set(static_linker_flags "-static-libstdc++ -static-libgcc")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${static_linker_flags}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${static_linker_flags}")
  unset(static_linker_flags)
  set(GPERFTOOLS_USE_STATIC_LIBS TRUE)
endif()
include(CheckCxxAtomic)
if(NOT HAVE_CXX11_ATOMIC)
  set(CMAKE_CXX_STANDARD_LIBRARIES
    "${CMAKE_CXX_STANDARD_LIBRARIES} ${LIBATOMIC_LINK_FLAGS}")
endif()

option(WITH_RDMA "Enable RDMA in async messenger" ON)
if(WITH_RDMA)
  find_package(verbs REQUIRED)
  set(HAVE_VERBS ${VERBS_FOUND})
  find_package(rdmacm REQUIRED)
  set(HAVE_RDMACM ${RDMACM_FOUND})
  set(HAVE_RDMA TRUE)
endif()

find_package(Backtrace)

option(WITH_RBD "Enable RADOS Block Device related targets" ON)

if(LINUX)
  find_package(udev REQUIRED)
  set(HAVE_UDEV ${UDEV_FOUND})
  find_package(blkid REQUIRED)
  set(HAVE_BLKID ${BLKID_FOUND})
  find_package(keyutils REQUIRED)
  set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
elseif(FREEBSD)
  set(HAVE_UDEV OFF)
  set(HAVE_LIBAIO OFF)
  set(HAVE_BLKID OFF)
  set(HAVE_KEYUTILS OFF)
else()
  set(HAVE_UDEV OFF)
  set(HAVE_BLKID OFF)
endif(LINUX)

option(WITH_OPENLDAP "OPENLDAP is here" ON)
if(WITH_OPENLDAP)
  find_package(OpenLdap REQUIRED)
  set(HAVE_OPENLDAP ${OPENLDAP_FOUND})
endif()

option(WITH_GSSAPI "GSSAPI/KRB5 is here" OFF)
if(WITH_GSSAPI)
  find_package(GSSApi REQUIRED)
  set(HAVE_GSSAPI ${GSSApi_FOUND})
endif()

option(WITH_FUSE "Fuse is here" ON)
if(WITH_FUSE)
  find_package(fuse)
  set(HAVE_LIBFUSE ${FUSE_FOUND})
endif()

option(WITH_XFS "XFS is here" ON)
if(WITH_XFS)
  find_package(xfs)
  set(HAVE_LIBXFS ${XFS_FOUND})
endif()

option(WITH_ZFS "enable LibZFS if found" OFF)
if(WITH_ZFS)
  find_package(zfs)
  set(HAVE_LIBZFS ${ZFS_FOUND})
endif()

option(WITH_BLUESTORE "Bluestore OSD backend" ON)
if(WITH_BLUESTORE)
  if(LINUX)
    find_package(aio)
    set(HAVE_LIBAIO ${AIO_FOUND})
  elseif(FREEBSD)
    # POSIX AIO is integrated into FreeBSD kernel, and exposed by libc.
    set(HAVE_POSIXAIO ON)
  endif()
endif()

include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(WITH_LIBURING "Build with liburing library support" OFF
  "WITH_BLUESTORE;HAVE_LIBAIO" OFF)
set(HAVE_LIBURING ${WITH_LIBURING})

CMAKE_DEPENDENT_OPTION(WITH_BLUESTORE_PMEM "Enable PMDK libraries" OFF
  "WITH_BLUESTORE" OFF)

CMAKE_DEPENDENT_OPTION(WITH_RBD_RWL "Enable librbd persistent write back cache" OFF
  "WITH_RBD" OFF)

CMAKE_DEPENDENT_OPTION(WITH_SYSTEM_PMDK "Require and build with system PMDK" OFF
  "WITH_RBD_RWL OR WITH_BLUESTORE_PMEM" OFF)

if(WITH_BLUESTORE_PMEM)
  set(HAVE_BLUESTORE_PMEM ON)
endif()

CMAKE_DEPENDENT_OPTION(WITH_SPDK "Enable SPDK" OFF
  "CMAKE_SYSTEM_PROCESSOR MATCHES i386|i686|amd64|x86_64|AMD64|aarch64" OFF)
if(WITH_SPDK)
  if(NOT WITH_BLUESTORE)
    message(SEND_ERROR "Please enable WITH_BLUESTORE for using SPDK")
  endif()
  include(BuildSPDK)
  build_spdk()
  set(HAVE_SPDK TRUE)
endif(WITH_SPDK)

if(WITH_BLUESTORE)
  if(NOT AIO_FOUND AND NOT HAVE_POSIXAIO AND NOT WITH_SPDK AND NOT WITH_BLUESTORE_PMEM)
    message(SEND_ERROR "WITH_BLUESTORE is ON, "
      "but none of the bluestore backends is enabled. "
      "Please install libaio, or enable WITH_SPDK or WITH_BLUESTORE_PMEM (experimental)")
  endif()
endif()

option(WITH_BLUEFS "libbluefs library" OFF)

option(WITH_QATZIP "Enable QATZIP" OFF)
if(WITH_QATZIP)
  find_package(qatzip REQUIRED)
  set(HAVE_QATZIP ${QATZIP_FOUND})
endif(WITH_QATZIP)

# needs mds and? XXX
option(WITH_LIBCEPHFS "libcephfs client library" ON)

# key-value store
option(WITH_KVS "Key value store is here" ON)

option(WITH_KRBD "Enable Linux krbd support of 'rbd' utility" ON)

if(WITH_KRBD AND NOT WITH_RBD)
  message(FATAL_ERROR "Cannot have WITH_KRBD without WITH_RBD.")
endif()
if(LINUX)
  if(WITH_LIBCEPHFS OR WITH_KRBD)
    # keyutils is only used when talking to the Linux Kernel key store 
    find_package(keyutils REQUIRED)
    set(HAVE_KEYUTILS ${KEYUTILS_FOUND})
  endif()
endif()

option(WITH_LEVELDB "LevelDB is here" ON)
if(WITH_LEVELDB)
  if(LEVELDB_PREFIX)
    include_directories(SYSTEM ${LEVELDB_PREFIX}/include)
    link_directories(${LEVELDB_PREFIX}/lib)
  endif()
  find_package(leveldb REQUIRED)
  find_file(HAVE_LEVELDB_FILTER_POLICY leveldb/filter_policy.h PATHS ${LEVELDB_INCLUDE_DIR})
endif(WITH_LEVELDB)

find_package(snappy REQUIRED)

option(WITH_BROTLI "Brotli compression support" OFF)
if(WITH_BROTLI)
  set(HAVE_BROTLI TRUE)
endif()

option(WITH_LZ4 "LZ4 compression support" ON)
if(WITH_LZ4)
  find_package(LZ4 1.7 REQUIRED)
  set(HAVE_LZ4 ${LZ4_FOUND})
endif(WITH_LZ4)

option(WITH_CEPH_DEBUG_MUTEX "Use debug ceph::mutex with lockdep" OFF)

#if allocator is set on command line make sure it matches below strings
set(ALLOCATOR "" CACHE STRING
  "specify memory allocator to use. currently tcmalloc, tcmalloc_minimal, \
jemalloc, and libc is supported. if not specified, will try to find tcmalloc, \
and then jemalloc. If neither of then is found. use the one in libc.")
if(ALLOCATOR)
  if(${ALLOCATOR} MATCHES "tcmalloc(_minimal)?")
    find_package(gperftools REQUIRED)
    set(HAVE_LIBTCMALLOC ON)
  elseif(${ALLOCATOR} STREQUAL "jemalloc")
    find_package(JeMalloc REQUIRED)
    set(HAVE_JEMALLOC 1)
  elseif(NOT ALLOCATOR STREQUAL "libc")
    message(FATAL_ERROR "Unsupported allocator selected: ${ALLOCATOR}")
  endif()
else(ALLOCATOR)
  find_package(gperftools)
  set(HAVE_LIBTCMALLOC ${gperftools_FOUND})
  if(NOT gperftools_FOUND)
    find_package(JeMalloc)
  endif()
  if(gperftools_FOUND)
    set(ALLOCATOR tcmalloc)
  elseif(JeMalloc_FOUND)
    set(ALLOCATOR jemalloc)
  else()
    if(NOT FREEBSD)
      # FreeBSD already has jemalloc as its default allocator
      message(WARNING "tcmalloc and jemalloc not found, falling back to libc")
    endif()
    set(ALLOCATOR "libc")
  endif(gperftools_FOUND)
endif(ALLOCATOR)

if(HAVE_LIBTCMALLOC AND WITH_STATIC_LIBSTDCXX)
  set(EXE_LINKER_USE_PIE FALSE)
else()
  set(EXE_LINKER_USE_PIE ${ENABLE_SHARED})
endif()

if (HAVE_LIBTCMALLOC AND TCMALLOC_VERSION_STRING VERSION_LESS 2.6.2)
  set(LIBTCMALLOC_MISSING_ALIGNED_ALLOC ON)
endif()

find_package(CURL REQUIRED)
set(CMAKE_REQUIRED_INCLUDES ${CURL_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${CURL_LIBRARIES})
CHECK_SYMBOL_EXISTS(curl_multi_wait curl/curl.h HAVE_CURL_MULTI_WAIT)

find_package(OpenSSL REQUIRED)
set(CRYPTO_LIBS OpenSSL::Crypto)

option(WITH_DPDK "Enable DPDK messaging" OFF)
if(WITH_DPDK)
  find_package(dpdk)
  if(NOT DPDK_FOUND)
    include(BuildDPDK)
    build_dpdk(${CMAKE_BINARY_DIR}/src/dpdk)
  endif()
  set(HAVE_DPDK TRUE)
endif()

option(WITH_BLKIN "Use blkin to emit LTTng tracepoints for Zipkin" OFF)
if(WITH_BLKIN)
  set(BLKIN_LIBRARIES blkin ${LTTNGUST_LIBRARIES} lttng-ust-fork)
  include_directories(SYSTEM src/blkin/blkin-lib)
endif(WITH_BLKIN)

option(WITH_BOOST_CONTEXT "Enable boost::asio stackful coroutines" ON)
if(WITH_BOOST_CONTEXT)
  set(HAVE_BOOST_CONTEXT ON)
endif()

#option for RGW
option(WITH_RADOSGW "Rados Gateway is enabled" ON)
option(WITH_RADOSGW_FCGI_FRONTEND "Rados Gateway's FCGI frontend is enabled" OFF)
option(WITH_RADOSGW_BEAST_FRONTEND "Rados Gateway's Beast frontend is enabled" ON)
option(WITH_RADOSGW_BEAST_OPENSSL "Rados Gateway's Beast frontend uses OpenSSL" ON)
option(WITH_RADOSGW_AMQP_ENDPOINT "Rados Gateway's pubsub support for AMQP push endpoint" ON)
option(WITH_RADOSGW_KAFKA_ENDPOINT "Rados Gateway's pubsub support for Kafka push endpoint" ON)

if(WITH_RADOSGW)
  find_package(EXPAT REQUIRED)
  if(WITH_RADOSGW_FCGI_FRONTEND)
    find_package(fcgi REQUIRED)
  endif()
  if(WITH_RADOSGW_BEAST_FRONTEND AND NOT WITH_BOOST_CONTEXT)
    message(WARNING "disabling WITH_RADOSGW_BEAST_FRONTEND, which depends on WITH_BOOST_CONTEXT")
    set(WITH_RADOSGW_BEAST_FRONTEND OFF)
  endif()
  find_package(OATH REQUIRED)

# https://curl.haxx.se/docs/install.html mentions the
# configure flags for various ssl backends
  execute_process(
    COMMAND
  "sh" "-c"
  "curl-config --configure | grep with-ssl"
  RESULT_VARIABLE NO_CURL_SSL_LINK
  ERROR_VARIABLE CURL_CONFIG_ERRORS
  )
  if (CURL_CONFIG_ERRORS)
    message(WARNING "unable to run curl-config; rgw cannot make ssl requests to external systems reliably")
  endif()

  if (NOT NO_CURL_SSL_LINK)
    message(STATUS "libcurl is linked with openssl: explicitly setting locks")
    set(WITH_CURL_OPENSSL ON)
  endif() # CURL_SSL_LINK
  execute_process(
    COMMAND
      "sh" "-c"
      "objdump -p ${OPENSSL_SSL_LIBRARY} | sed -n 's/^  SONAME  *//p'"
    OUTPUT_VARIABLE LIBSSL_SONAME
    ERROR_VARIABLE OBJDUMP_ERRORS
    RESULT_VARIABLE OBJDUMP_RESULTS
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (OBJDUMP_RESULTS)
    message(FATAL_ERROR "can't run objdump: ${OBJDUMP_RESULTS}")
  endif()
  if (NOT OBJDUMP_ERRORS STREQUAL "")
    message(WARNING "message from objdump: ${OBJDUMP_ERRORS}")
  endif()
